/*
* ============================================================================
*  Name        : mccexappdocument.h
*  Part of     : mccexample / mccexapp
*  Description : CMccExAppDocument declaration
*  Version     : %version: %
*
*  Copyright  2008-2009 Nokia.  All rights reserved.
*  This material, including documentation and any related computer
*  programs, is protected by copyright controlled by Nokia.  All
*  rights are reserved.  Copying, including reproducing, storing,
*  adapting or translating, any or all of this material requires the
*  prior written consent of Nokia.  This material also contains
*  confidential information which may not be disclosed to others
*  without the prior written consent of Nokia.
* ============================================================================
* Template version: 4.2
*/

#ifndef C_CMCCEXAPPDOCUMENT_H
#define C_CMCCEXAPPDOCUMENT_H

#include <akndoc.h>

class CMccExAppUi;

/**
 * CMccExAppDocument application class.
 * An instance of class CMccExAppDocument is the Document part of the
 * AVKON application framework for the MccExample example application.
 */
class CMccExAppDocument : public CAknDocument
    {
public:

    /**
     * NewL. Two-phased constructor.
     * Construct a CMccExAppDocument for the AVKON application aApp using two
     * phase construction, and return a pointer to the created object.
     * 
     * @param aApp Application creating this document.
     * @return A pointer to the created instance of CMccExAppDocument.
     */
    static CMccExAppDocument* NewL( CEikApplication& aApp );

    /**
     * NewLC. Two-phased constructor.
     * Construct a CMccExAppDocument for the AVKON application aApp using two
     * phase construction, and return a pointer to the created object.
     * 
     * @param aApp Application creating this document.
     * @return A pointer to the created instance of CMccExAppDocument.
     */
    static CMccExAppDocument* NewLC( CEikApplication& aApp );

    /**
     * ~CMccExAppDocument Destructor.
     */
    virtual ~CMccExAppDocument();

// from CEikDocument

    /**
     * From CEikDocument.
     * Create a CMccExAppUi object and return a pointer to it. The object
     * returned is owned by the Uikon framework.
     * 
     * @see CEikDocument
     * @return Pointer to created instance of AppUi.
     */
    CEikAppUi* CreateAppUiL();

private:

    /**
     * 2nd phase constructor.
     */
    void ConstructL();

    /**
     * CMccExAppDocument. C++ default constructor.
     * 
     * @param aApp Application creating this document.
     */
    CMccExAppDocument( CEikApplication& aApp );

    };

#endif // C_CMCCEXAPPDOCUMENT_H
