/*
* ============================================================================
*  Name        : audiostreambase.cpp
*  Part of     : mccexample / mccexengine
*  Description : CAudioStreamBase class implementation
*  Version     : %version: %
*
*  Copyright  2008-2009 Nokia.  All rights reserved.
*  This material, including documentation and any related computer
*  programs, is protected by copyright controlled by Nokia.  All
*  rights are reserved.  Copying, including reproducing, storing,
*  adapting or translating, any or all of this material requires the
*  prior written consent of Nokia.  This material also contains
*  confidential information which may not be disclosed to others
*  without the prior written consent of Nokia.
* ============================================================================
* Template version: 4.1.1
*/

#include <mmcccodecinformation.h>
#include <mmccinterfacedef.h>
#include <mmccinterface.h>

#include "audiostreambase.h"

// ======== MEMBER FUNCTIONS ========

// ---------------------------------------------------------------------------
// CAudioStreamBase::CAudioStreamBase
// ---------------------------------------------------------------------------
//
CAudioStreamBase::CAudioStreamBase( CStreamStateMachine& aStateMachine,
    CMccInterface& aMcc, TUint32 aSession, TUint32 aLink  ) : 
    CStreamBase( aStateMachine, aMcc, aSession, aLink )
    {
    }


// ---------------------------------------------------------------------------
// CAudioStreamBase::~CAudioStreamBase
// ---------------------------------------------------------------------------
//
CAudioStreamBase::~CAudioStreamBase()
    {
    }


// ---------------------------------------------------------------------------
// CAudioStreamBase::ConstructL
// ---------------------------------------------------------------------------
//
void CAudioStreamBase::ConstructL( CMccCodecInformation& aCodec, TInt aType )
    {
    // Assert that we have gotten proper arguments
    __ASSERT_ALWAYS(
        KMccAudioDownlinkStream == aType || KMccAudioUplinkStream == aType,
        User::Leave( KErrArgument ) );
    __ASSERT_ALWAYS( KUidMediaTypeAudio == aCodec.Type(),
        User::Leave( KErrArgument ) );
    
    CStreamBase::ConstructL( aCodec, aType );
    }


// ---------------------------------------------------------------------------
// CAudioStreamBase::SetCodecPriorityAndPreference
// ---------------------------------------------------------------------------
//
void CAudioStreamBase::SetCodecPriorityAndPreference( TInt aPriority,
    TInt aPreference )
    {
    CMccCodecInformation& codec = Codec();
    codec.SetPriority( aPriority );
    codec.SetPriorityPreference( aPreference );
    }
