/*
* ============================================================================
*  Name        : streamstatebase.cpp
*  Part of     : mccexample / mccexengine
*  Description : CStreamStateBase implementation
*  Version     : %version: %
*
*  Copyright  2008-2009 Nokia.  All rights reserved.
*  This material, including documentation and any related computer
*  programs, is protected by copyright controlled by Nokia.  All
*  rights are reserved.  Copying, including reproducing, storing,
*  adapting or translating, any or all of this material requires the
*  prior written consent of Nokia.  This material also contains
*  confidential information which may not be disclosed to others
*  without the prior written consent of Nokia.
* ============================================================================
* Template version: 4.1.1
*/

#include <mmccevents.h>

#include "streamstatebase.h"
#include "streambase.h"
#include "mccexpanic.pan"

// ======== MEMBER FUNCTIONS ========

// ---------------------------------------------------------------------------
// CStreamStateBase::CStreamStateBase
// ---------------------------------------------------------------------------
//
CStreamStateBase::CStreamStateBase()
    {
    }


// ---------------------------------------------------------------------------
// CStreamStateBase::~CStreamStateBase
// ---------------------------------------------------------------------------
//
CStreamStateBase::~CStreamStateBase()
    {
    }


// ---------------------------------------------------------------------------
// CStreamStateBase::EnterStateL
// ---------------------------------------------------------------------------
//
void CStreamStateBase::EnterStateL( CStreamBase& aStream,
    const CStreamStateBase& aPrevState )
    {
    DoEnterStateL( aStream, aPrevState );
    }


// ---------------------------------------------------------------------------
// CStreamStateBase::HandleMccEvent
// ---------------------------------------------------------------------------
//
void CStreamStateBase::HandleMccEvent( const TMccEvent& aEvent,
    CStreamBase& aStream )
    {
    if ( aStream.SinkEndpointId() == aEvent.iEndpointId )
        {
        aStream.SinkIsReady();
        }
    else if ( aStream.SourceEndpointId() == aEvent.iEndpointId )
        {
        aStream.SourceIsReady();
        }
    // else a no-operation
    }

